<?php 
require_once(dirname(__FILE__) . "/includes/license.class.php");
if( get_option("cc_whmcs_bridge_sso_active") ) 
{
    $zl = new WhmcsProLicense(WHMCS_BRIDGE, "cc_whmcs_bridge_sso");
    if( $zl->check() == md5(WHMCS_BRIDGE . "cc_whmcs_bridge_sso" . $zl->time() . "livelounge") ) 
    {
        unset($zl);
        require_once(dirname(__FILE__) . "/includes/connect.class.php");
        require_once(dirname(__FILE__) . "/includes/wpusers.class.php");
        require_once(dirname(__FILE__) . "/includes/hooks.inc.php");
        require_once(dirname(__FILE__) . "/includes/pretty-parser.inc.php");
        add_filter("zHttpRequest_pre", "cc_whmcs_sso_set_cookies");
        add_filter("zHttpRequest_post", "cc_whmcs_sso_save_cookies");
    }
    else
    {
        unset($zl);
    }

    add_action("admin_notices", "cc_whmcs_sso_admin_notices");
}

function cc_whmcs_sso_set_cookies($cookies)
{
    if( isset($_COOKIE["WHMCSAffiliateID"]) && $_COOKIE["WHMCSAffiliateID"] ) 
    {
        if( $cookies ) 
        {
            $cookies .= ";";
        }

        $cookies .= "WHMCSAffiliateID=" . $_COOKIE["WHMCSAffiliateID"];
    }

    return $cookies;
}

function cc_whmcs_sso_save_cookies($cookies)
{
    $WHMCSAffiliateID = NULL;
    $expires = NULL;
    if( !$cookies ) 
    {
        return $cookies;
    }

    $c = explode(";", $cookies);
    foreach( $c as $p ) 
    {
        list($n, $v) = explode("=", $p);
        if( trim($n) == "WHMCSAffiliateID" ) 
        {
            $WHMCSAffiliateID = trim($v);
        }

        if( !$expires && trim($n) == "expires" ) 
        {
            $expires = trim($v);
        }

    }
    if( $WHMCSAffiliateID ) 
    {
        setcookie("WHMCSAffiliateID", $WHMCSAffiliateID, strtotime($expires), "/");
    }

    return $cookies;
}

function cc_whmcs_sso_admin_notices()
{
    global $ccCheckLicenseMessage;
    $messages = $notices = array(  );
    if( $ccCheckLicenseMessage ) 
    {
        $messages[] = $ccCheckLicenseMessage . ". If you changed your IP address, domain name or location of the plugin folder, you will need to reissue your licence. You can reset your license via our <a href=\"https://linkonym.appspot.com/?http://i-plugins.com/whmcs-bridge\" target=\"_blank\">client zone</a>.";
    }

    if( !defined("CC_WHMCS_BRIDGE_VERSION") && !get_option("cc_whmcs_bridge_version") ) 
    {
        $messages[] = WHMCS_BRIDGE_PRO . " adds functionality to " . WHMCS_BRIDGE . ". Please install " . WHMCS_BRIDGE . " first.";
    }

    if( isset($_REQUEST["page"]) && $_REQUEST["page"] == "cc-ce-bridge-cp" ) 
    {
        $messages[] = "Please make sure you have the " . "<a href=\"https://linkonym.appspot.com/?http://i-plugins.com/whmcs-bridge/?ccce=clientarea\" target=\"_blank\">WHMCS Bridge Helper addon " . "for WHMCS</a> version <strong>3.3</strong> or higher installed. If you have installed it, you can safely ignore this warning.";
    }

    if( 0 < count($messages) ) 
    {
        foreach( $messages as $message ) 
        {
            echo "<div id='zing-warning' style='background-color:greenyellow' class='updated fade'><p><strong>";
            echo $message . "<br />";
            echo "</strong> " . "</p></div>";
        }
    }

    if( 0 < count($notices) ) 
    {
        foreach( $notices as $message ) 
        {
            echo "<div id='zing-warning' style='background-color:lightyellow' class='updated fade'><p><strong>";
            echo $message . "<br />";
            echo "</strong> " . "</p></div>";
        }
    }

}

function cc_whmcs_bridge_sso_update()
{
    delete_option("cc_whmcs_bridge_sso_local_key");
}

function cc_whmcs_bridge_sso_activate()
{
    update_option("cc_whmcs_bridge_sso_active", dirname(__FILE__));
}

function cc_whmcs_bridge_sso_deactivate()
{
    delete_option("cc_whmcs_bridge_sso_active");
    delete_option("cc_whmcs_bridge_sso_start");
    delete_option("cc_whmcs_bridge_sso_syncing");
    delete_option("cc_whmcs_bridge_sso_wpsync_offset");
    delete_option("cc_whmcs_bridge_sso_synctype");
    delete_option("cc_whmcs_bridge_sso_version");
    delete_option("cc_whmcs_bridge_sso_secret");
    delete_option("cc_whmcs_bridge_sso_force_ssl");
    wp_clear_scheduled_hook("cc_whmcs_bridge_sso_cron_hook");
}


