<?php 
if( !class_exists("WhmcsProLicense") ) 
{
    exit( "Access denied 00A" );
}

$zl = new WhmcsProLicense(WHMCS_BRIDGE, "cc_whmcs_bridge_sso");
if( $zl->check() != md5(WHMCS_BRIDGE . "cc_whmcs_bridge_sso" . $zl->time() . "livelounge") ) 
{
    unset($zl);
    exit( "Access denied 01A" );
}

unset($zl);

class whmcs
{
    public function whmcs()
    {
    }

    public function loggedIn($email, $password)
    {
        $result = $this->connect("validatelogin", array( "email" => $email, "password2" => $password ));
        if( isset($result["userid"]) && $result["userid"] ) 
        {
            return true;
        }

        return false;
    }

    public function getUsers()
    {
        $range = 10;
        $limitstart = get_option("cc_whmcs_bridge_sso_start");
        if( $limitstart == false ) 
        {
            $limitstart = 0;
        }

        $results = $this->connect("getclients", array( "limitstart" => $limitstart, "limitnum" => $range ));
        if( isset($results["numreturned"]) && $results["numreturned"] == $range ) 
        {
            $next = $limitstart + $range;
            update_option("cc_whmcs_bridge_sso_start", $next);
        }
        else
        {
            update_option("cc_whmcs_bridge_sso_start", 0);
        }

        $clients = isset($results["clients"]) ? $results["clients"] : array(  );
        $limitstart = get_option("cc_whmcs_bridge_sso_start_contacts");
        if( $limitstart == false ) 
        {
            $limitstart = 0;
        }

        $results = $this->connect("getcontacts", array( "subaccount" => "true", "limitstart" => $limitstart, "limitnum" => $range ));
        if( isset($results["numreturned"]) && $results["numreturned"] == $range ) 
        {
            $next = $limitstart + $range;
            update_option("cc_whmcs_bridge_sso_start_contacts", $next);
        }
        else
        {
            update_option("cc_whmcs_bridge_sso_start_contacts", 0);
        }

        $contacts = isset($results["contacts"]) ? $results["contacts"] : array(  );
        return array( "clients" => $clients, "contacts" => $contacts );
    }

    public function getClient($email, $contact = false)
    {
        if( !$contact ) 
        {
            cc_whmcs_log(0, "Get WHMCS client: " . $email);
            $results = $this->connect("getclientsdetails", array( "email" => $email ));
        }
        else
        {
            cc_whmcs_log(0, "Get WHMCS contact: " . $email);
            $results = $this->connect("getcontacts", array( "subaccount" => "true", "email" => $email ));
            $results = isset($results["contacts"]) ? $results["contacts"] : array(  );
        }

        return $results;
    }

    public function addClient($first_name, $last_name, $email, $nicename, $password, $username)
    {
        $postfields["firstname"] = $first_name ? $first_name : $nicename;
        $postfields["lastname"] = $last_name ? $last_name : $nicename;
        $postfields["email"] = $email;
        $validation_setting = get_option("cc_whmcs_bridge_sso_validation");
        if( $validation_setting == "checked" ) 
        {
            $postfields["address1"] = "";
            $postfields["city"] = "";
            $postfields["state"] = "";
            $postfields["postcode"] = "";
            $postfields["country"] = "";
            $postfields["phonenumber"] = "";
        }
        else
        {
            $postfields["address1"] = "TBC";
            $postfields["city"] = "TBC";
            $postfields["state"] = "TBC";
            $postfields["postcode"] = "UNK123";
            $postfields["country"] = "US";
            $postfields["phonenumber"] = "123456789";
        }

        $postfields["password2"] = md5("whmcsbridgebyzingiri" . $password);
        if( $usernameCustomField = get_option("cc_whmcs_bridge_sso_username") ) 
        {
            $postfields["customfields"] = base64_encode(serialize(array( $usernameCustomField => $username )));
        }

        $postfields["skipvalidation"] = true;
        $postfields["noemail"] = true;
        cc_whmcs_log(0, "Validation setting: " . get_option("cc_whmcs_bridge_sso_validation"));
        cc_whmcs_log(0, "Add WHMCS client: " . $email);
        $results = $this->connect("addclient", $postfields);
        return $results;
    }

    public function updateClientPassword($id, $password, $contact = false)
    {
        if( !$contact ) 
        {
            $postfields["clientid"] = $id;
            $postfields["password2"] = $password;
            cc_whmcs_log(0, "Update WHMCS client password: " . $id);
            $results = $this->connect("updateclient", $postfields);
        }
        else
        {
            $postfields["contactid"] = $id;
            $postfields["password2"] = $password;
            cc_whmcs_log(0, "Update WHMCS contact password: " . $id);
            $results = $this->connect("updatecontact", $postfields);
        }

        return $results;
    }

    public function logoutClient()
    {
        $http = cc_whmcs_bridge_http("logout");
        $news = new zHttpRequest($http, "whmcs-bridge-sso");
        $news->debugFunction = "cc_whmcs_log";
        $news->httpHeaders = cc_whmcs_bridge_sso_httpHeaders($news->httpHeaders);
        $news->post = array(  );
        $output = $news->DownloadToString(true, false);
    }

    public function loginClient($email, $password)
    {
        $client = $this->getClient($email);
        $contact = $this->getClient($email, true);
        if( isset($client["userid"]) ) 
        {
            $result = $this->updateClientPassword($client["userid"], $password);
        }
        else
        {
            if( 0 < count($contact) ) 
            {
                foreach( $contact as $id => $data ) 
                {
                    $result = $this->updateClientPassword($id, $password, true);
                }
            }

        }

        $http = cc_whmcs_bridge_http("dologin");
        $news = new zHttpRequest($http, "whmcs-bridge-sso");
        $news->debugFunction = "cc_whmcs_log";
        $news->httpHeaders = cc_whmcs_bridge_sso_httpHeaders($news->httpHeaders);
        $news->post = array(  );
        $news->post["username"] = $email;
        $news->post["password"] = $password;
        $news->post["rememberme"] = "on";
        $output = $news->DownloadToString(true, false);
    }

    public function autoLoginClient($email, $autoAuthKey)
    {
        $whmcsurl = cc_whmcs_bridge_url() . "/dologin.php";
        $timestamp = time();
        echo date("Y-m-d H:i:s", $timestamp);
        $goto = "clientarea.php?action=products";
        $hash = sha1($email . $timestamp . $autoAuthKey);
        $http = cc_whmcs_bridge_http("dologin");
        $http .= "&email=" . $email . "&hash=" . $hash . "&goto=" . urlencode($goto) . "&timestamp=" . $timestamp;
        echo "<code>" . htmlentities($http) . "</code>";
        echo "<hr />";
        $news = new zHttpRequest($http, "whmcs-bridge-sso");
        $news->debugFunction = "cc_whmcs_log";
        $news->httpHeaders = cc_whmcs_bridge_sso_httpHeaders($news->httpHeaders);
        $output = $news->DownloadToString(true, false);
        echo $output;
        exit();
    }

    public function checkLoggedIn()
    {
    }

    public function updateClient($id, $email, $firstname, $lastname, $password, $contact = false)
    {
        $a = array(  );
        if( $firstname ) 
        {
            $a["firstname"] = $firstname;
        }

        if( $lastname ) 
        {
            $a["lastname"] = $lastname;
        }

        if( $password ) 
        {
            $a["password2"] = $password;
        }

        if( $email ) 
        {
            $a["email"] = $email;
        }

        if( 0 < count($a) ) 
        {
            if( !$contact ) 
            {
                $a["clientid"] = $id;
                $results = $this->connect("updateclient", $a);
            }
            else
            {
                $a["contactid"] = $id;
                $results = $this->connect("updatecontact", $a);
            }

        }

    }

    public function encrypt($input)
    {
        $results = $this->connect("encryptpassword", array( "password2" => $input ));
        return isset($results["password"]) ? $results["password"] : false;
    }

    public function decrypt($input)
    {
        $results = $this->connect("decryptpassword", array( "password2" => $input ));
        return $results["password"];
    }

    public function connect($action, $params)
    {
        $url = get_option("cc_whmcs_bridge_url") . "/includes/api.php";
        $username = get_option("cc_whmcs_bridge_admin_login");
        $password = get_option("cc_whmcs_bridge_admin_password");
        $postfields["username"] = $username;
        $postfields["password"] = md5($password);
        $postfields["action"] = $action;
        $postfields = array_merge($postfields, $params);
        cc_whmcs_log(0, "WHMCS connect: " . $url . " with post parameters " . print_r($postfields, true));
        $t = apply_filters("bridge_connect", array( $url, $postfields ));
        list($url, $postfields) = $t;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        if( stristr($url, "https://") !== false ) 
        {
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
            curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
            curl_setopt($ch, CURLOPT_CAINFO, NULL);
            curl_setopt($ch, CURLOPT_CAPATH, NULL);
        }

        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_TIMEOUT, 100);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array( "Expect:" ));
        $data = curl_exec($ch);
        if( curl_errno($ch) ) 
        {
            $this->errno = curl_errno($ch);
            $this->error = curl_error($ch);
            cc_whmcs_log("HTTP Error:" . $this->errno . "/" . $this->error . " at " . $url);
            return false;
        }

        curl_close($ch);
        $pos = strpos($data, "<?xml version=\"1.0\" encoding=\"utf-8\"?>");
        if( 0 < $pos ) 
        {
            $data = substr($data, $pos);
        }

        if( empty($data) ) 
        {
            cc_whmcs_log(0, "WHMCS returned no data");
        }
        else
        {
            cc_whmcs_log(0, "WHMCS returned: " . print_r($data, true));
        }

        if( substr($data, 0, 1) == "<" && $action == "getcontacts" ) 
        {
            $dom = new DOMDocument();
            $data = forceUTF8($data);
            if( $dom->loadXML($data) ) 
            {
                if( !$dom ) 
                {
                    header("Location: " . get_admin_url() . "options-general.php?page=cc-ce-bridge-cp&error=" . urlencode("Error 1 while parsing the document"));
                    exit();
                }

                $xml = simplexml_import_dom($dom);
                $results["numreturned"] = (int) $xml->numreturned;
                $results["result"] = (string) $xml->result;
                if( 0 < $xml->totalresults && $xml->contacts ) 
                {
                    foreach( $xml->contacts->children() as $client ) 
                    {
                        $results["contacts"][(string) $client->id] = array( "email" => (string) $client->email, "firstname" => (string) $client->firstname, "lastname" => (string) $client->lastname, "companyname" => (string) $client->companyname );
                    }
                }

            }
            else
            {
                header("Location: " . get_admin_url() . "options-general.php?page=cc-ce-bridge-cp&error=" . urlencode("Error 2 while parsing the document"));
                exit();
            }

        }
        else
        {
            if( substr($data, 0, 1) == "<" && $action == "getclients" ) 
            {
                $dom = new DOMDocument();
                $data = forceUTF8($data);
                if( $dom->loadXML($data) ) 
                {
                    if( !$dom ) 
                    {
                        header("Location: " . get_admin_url() . "options-general.php?page=cc-ce-bridge-cp&error=" . urlencode("Error 1 while parsing the document"));
                        exit();
                    }

                    $xml = simplexml_import_dom($dom);
                    $results["numreturned"] = (int) $xml->numreturned;
                    $results["result"] = (string) $xml->result;
                    if( 0 < $xml->totalresults && $xml->clients ) 
                    {
                        foreach( $xml->clients->children() as $client ) 
                        {
                            $results["clients"][(string) $client->id] = array( "email" => (string) $client->email );
                        }
                    }

                }
                else
                {
                    header("Location: " . get_admin_url() . "options-general.php?page=cc-ce-bridge-cp&error=" . urlencode("Error 2 while parsing the document"));
                    exit();
                }

            }
            else
            {
                if( $action == "decryptpassword" && stristr($data, "result=success") !== false ) 
                {
                    $temp = explode("password=", $data);
                    $temp[1] = substr($temp[1], 0, -1);
                    $results["result"] = "success";
                    $results["password"] = $temp[1];
                }
                else
                {
                    $data = explode(";", $data);
                    foreach( $data as $temp ) 
                    {
                        $temp = explode("=", $temp);
                        if( isset($temp[1]) ) 
                        {
                            $results[trim($temp[0])] = $temp[1];
                        }

                    }
                }

            }

        }

        if( isset($results["result"]) && $results["result"] == "success" ) 
        {
            cc_whmcs_log(0, "Connection successful");
        }
        else
        {
            if( isset($results["result"]) && $results["result"] == "error" ) 
            {
                cc_whmcs_log(0, "Connection successful, with error: " . $results["message"]);
            }
            else
            {
                if( empty($data) ) 
                {
                    cc_whmcs_log(0, "Connection not successful, WHMCS returned no data");
                }
                else
                {
                    cc_whmcs_log(0, "Connection not successful, WHMCS returned unreadable data: " . print_r($data, true));
                }

            }

        }

        return $results;
    }

}

/**
 * @author   "Sebastián Grignoli" <grignoli@framework2.com.ar>
 * @package  forceUTF8
 * @version  1.1
 * @link     http://www.framework2.com.ar/dzone/forceUTF8-es/
 * @example  http://www.framework2.com.ar/dzone/forceUTF8-es/
 */

function forceUTF8($text)
{
    if( is_array($text) ) 
    {
        foreach( $text as $k => $v ) 
        {
            $text[$k] = forceUTF8($v);
        }
        return $text;
    }

    $max = strlen($text);
    $buf = "";
    for( $i = 0; $i < $max; $i++ ) 
    {
        $c1 = $text[$i];
        if( "" <= $c1 ) 
        {
            $c2 = $max <= $i + 1 ? "" : $text[$i + 1];
            $c3 = $max <= $i + 2 ? "" : $text[$i + 2];
            $c4 = $max <= $i + 3 ? "" : $text[$i + 3];
            if( "" <= $c1 & $c1 <= "" ) 
            {
                if( "" <= $c2 && $c2 <= "" ) 
                {
                    $buf .= $c1 . $c2;
                    $i++;
                }
                else
                {
                    $cc1 = chr(ord($c1) / 64) | "";
                    $cc2 = $c1 & "?" | "";
                    $buf .= $cc1 . $cc2;
                }

            }
            else
            {
                if( "" <= $c1 & $c1 <= "" ) 
                {
                    if( "" <= $c2 && $c2 <= "" && "" <= $c3 && $c3 <= "" ) 
                    {
                        $buf .= $c1 . $c2 . $c3;
                        $i = $i + 2;
                    }
                    else
                    {
                        $cc1 = chr(ord($c1) / 64) | "";
                        $cc2 = $c1 & "?" | "";
                        $buf .= $cc1 . $cc2;
                    }

                }
                else
                {
                    if( "" <= $c1 & $c1 <= "" ) 
                    {
                        if( "" <= $c2 && $c2 <= "" && "" <= $c3 && $c3 <= "" && "" <= $c4 && $c4 <= "" ) 
                        {
                            $buf .= $c1 . $c2 . $c3;
                            $i = $i + 2;
                        }
                        else
                        {
                            $cc1 = chr(ord($c1) / 64) | "";
                            $cc2 = $c1 & "?" | "";
                            $buf .= $cc1 . $cc2;
                        }

                    }
                    else
                    {
                        $cc1 = chr(ord($c1) / 64) | "";
                        $cc2 = $c1 & "?" | "";
                        $buf .= $cc1 . $cc2;
                    }

                }

            }

        }
        else
        {
            if( ($c1 & "") == "" ) 
            {
                $cc1 = chr(ord($c1) / 64) | "";
                $cc2 = $c1 & "?" | "";
                $buf .= $cc1 . $cc2;
            }
            else
            {
                $buf .= $c1;
            }

        }

    }
    return $buf;
}

function forceLatin1($text)
{
    if( is_array($text) ) 
    {
        foreach( $text as $k => $v ) 
        {
            $text[$k] = forceLatin1($v);
        }
        return $text;
    }

    return utf8_decode(forceutf8($text));
}

function fixUTF8($text)
{
    if( is_array($text) ) 
    {
        foreach( $text as $k => $v ) 
        {
            $text[$k] = fixUTF8($v);
        }
        return $text;
    }

    $last = "";
    while( $last != $text ) 
    {
        $last = $text;
        $text = forceutf8(utf8_decode(forceutf8($text)));
    }
    return $text;
}


