<?php 
if( !class_exists("WhmcsProLicense") ) 
{
    exit( "Access denied 00D" );
}

$zl = new WhmcsProLicense(WHMCS_BRIDGE, "cc_whmcs_bridge_sso");
if( $zl->check() != md5(WHMCS_BRIDGE . "cc_whmcs_bridge_sso" . $zl->time() . "livelounge") ) 
{
    unset($zl);
    exit( "Access denied 01D" );
}

unset($zl);
add_action("wp_footer", "cc_whmcs_bridge_sso_shutdown");
add_action("init", "cc_whmcs_sync_users");
if( get_option("cc_whmcs_bridge_sso_singlesignon") ) 
{
    add_action("wp_login", "cc_whmcs_bridge_login");
    add_action("wp_logout", "cc_whmcs_bridge_logout");
    add_filter("check_password", "cc_whmcs_bridge_check_password", 10, 4);
    add_action("profile_update", "cc_whmcs_bridge_profile_update");
    add_action("user_register", "cc_whmcs_bridge_sso_user_register");
    add_filter("authenticate", "cc_whmcs_bridge_sso_authenticate", 10, 3);
}

add_action("init", "cc_whmcs_bridge_sso_init");
add_action("wp_head", "cc_whmcs_bridge_sso_header");
add_action("admin_menu", "cc_whmcs_bridge_sso_reset_license");
add_shortcode("whmcsbridge", "cc_whmcsbridge_sso_shortcode");
add_action("wp_head", "cc_whmcs_bridge_sso_setvars", 9);
add_filter("the_content", "cc_whmcs_bridge_sso_setvars_in_content", 9);
add_filter("rewrite_rules_array", "cc_whmcs_bridge_sso_insert_rewrite_rules");
add_filter("query_vars", "cc_whmcs_bridge_sso_insert_query_vars");
add_action("wp_loaded", "cc_whmcs_bridge_sso_flush_rules");
add_action("wp_ajax_whmcs_bridge_sso_sync", "whmcs_bridge_sso_sync_callback");
add_action("whmcs_bridge_sso_check", "whmcs_bridge_sso_check_callback");
function cc_whmcs_bridge_sso_header()
{
    $template = trim(get_option("cc_whmcs_bridge_template"));
    if( in_array($template, array( "default", "portal", "classic" )) ) 
    {
        echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . CC_WHMCS_BRIDGE_SSO_URL . "css/" . $template . ".css\" media=\"screen\" />";
    }

    echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"" . plugins_url("whmcs-bridge-sso") . "/css/bridge.css\" media=\"screen\" />";
    if( get_option("cc_whmcs_bridge_jquery") == "wp" ) 
    {
        echo "<script type=\"text/javascript\">" . "\n" . "var \$ = jQuery;" . "\n" . "</script>";
    }

}

function cc_whmcs_bridge_sso_reset_license()
{
    if( isset($_GET["page"]) && $_GET["page"] == "cc-ce-bridge-cp" && isset($_REQUEST["action"]) && "install" == $_REQUEST["action"] ) 
    {
        delete_option("cc_whmcs_bridge_sso_local_key");
    }

}

function cc_whmcs_bridge_sso_authenticate($user, $username, $password)
{
    if( !$username ) 
    {
        return NULL;
    }

    cc_whmcs_log(0, "Authenticate: " . $username);
    if( get_user_by("login", $username) ) 
    {
        return NULL;
    }

    $whmcs = new whmcs();
    $client = $whmcs->getClient($username);
    $contact = $whmcs->getClient($username, true);
    if( $client["result"] == "success" ) 
    {
        if( get_user_by("login", $client["email"]) || get_user_by("email", $client["email"]) ) 
        {
            return NULL;
        }

        cc_whmcs_log(0, "Client exists in WHMCS, lets create them in WP");
        $wpusers = new wpusers();
        $role = "subscriber";
        if( !$wpusers->createWpUser($role, $client["email"], $client["firstname"], $client["lastname"], $client["companyname"], create_sessionid(12)) ) 
        {
            cc_whmcs_log(0, "Creation ok");
        }
        else
        {
            cc_whmcs_log(0, "Creation failed:" . print_r($wpusers, true));
        }

    }
    else
    {
        if( 0 < count($contact) ) 
        {
            foreach( $contact as $client ) 
            {
                if( get_user_by("login", $client["email"]) || get_user_by("email", $client["email"]) ) 
                {
                    return NULL;
                }

                cc_whmcs_log(0, "Client exists as contact in WHMCS, lets create them in WP");
                $wpusers = new wpusers();
                $role = "subscriber";
                if( !$wpusers->createWpUser($role, $client["email"], $client["firstname"], $client["lastname"], $client["companyname"], create_sessionid(12)) ) 
                {
                    cc_whmcs_log(0, "Creation ok");
                }
                else
                {
                    cc_whmcs_log(0, "Creation failed:" . print_r($wpusers, true));
                }

            }
        }
        else
        {
            cc_whmcs_log(0, "Client doesn't in WHMCS");
        }

    }

}

function cc_whmcs_sync_users()
{
    if( !get_option("cc_whmcs_bridge_sso_syncing") || 60 < time() - get_option("cc_whmcs_bridge_sso_syncing") ) 
    {
        update_option("cc_whmcs_bridge_sso_syncing", time());
        $wpusers = new wpusers();
        $wpusers->sync();
    }

}

function cc_whmcs_bridge_login($login)
{
    cc_whmcs_log(0, "Login");
    $current_user = get_user_by("login", $login);
    $whmcs = new whmcs();
    $autoAuthKey = get_option("cc_whmcs_bridge_sso_autoauthkey");
    if( $autoAuthKey ) 
    {
        cc_whmcs_log(0, "Autokey used for " . $current_user->user_email . " - " . $autoAuthKey);
        $whmcs->autoLoginClient($current_user->user_email, $autoAuthKey);
    }
    else
    {
        cc_whmcs_log(0, "No autokey");
        $password = $whmcs->decrypt($_SESSION["whmcs-sso"]);
        if( !$whmcs->loggedIn($current_user->user_email, $password) ) 
        {
            cc_whmcs_log(0, "WHMCS not logged in with " . $current_user->user_email . " and " . $password);
            $client = $whmcs->getClient($current_user->user_email);
            if( isset($client["userid"]) ) 
            {
                $whmcs->updateClient($client["userid"], "", "", "", $password);
            }
            else
            {
                $contact = $whmcs->getClient($current_user->user_email, true);
                if( 0 < count($contact) ) 
                {
                    foreach( $contact as $id => $c ) 
                    {
                        $whmcs->updateClient($id, "", "", "", $password, true);
                    }
                }

            }

        }

        $whmcs->loginClient($current_user->user_email, $password);
    }

}

function cc_whmcs_bridge_logout()
{
    $whmcs = new whmcs();
    $whmcs->logoutClient();
}

/**
 * Allow user login using the WHMCS password
 *
 * @param $check
 * @param $password
 * @param $hash
 * @param $user_id
 * @return boolean
 */

function cc_whmcs_bridge_check_password($check, $password, $hash, $user_id)
{
    cc_whmcs_log(0, "Check password:" . $check);
    $whmcs = new whmcs();
    if( !$check ) 
    {
        $user = new WP_User($user_id);
        $check = $whmcs->loggedIn($user->data->user_email, $password);
    }

    $_SESSION["whmcs-sso"] = $whmcs->encrypt($password);
    cc_whmcs_log(0, "Password stored:" . $whmcs->encrypt($password));
    return $check;
}

function cc_whmcs_bridge_profile_update($user_id)
{
    global $whmcsID;
    $password = $_POST["pass1"];
    $user = new WP_User($user_id);
    $whmcs = new whmcs();
    $client = $whmcs->getClient($user->user_email);
    if( isset($client["userid"]) ) 
    {
        $whmcs->updateClient($client["userid"], $user->data->user_email, $user->data->first_name, $user->data->last_name, $password);
    }
    else
    {
        $contact = $whmcs->getClient($user->user_email, true);
        if( 0 < count($contact) ) 
        {
            foreach( $contact as $id => $c ) 
            {
                $whmcs->updateClient($id, $user->data->user_email, $user->data->first_name, $user->data->last_name, $password, true);
            }
        }

    }

    $_SESSION["whmcs-sso"] = $whmcs->encrypt($password);
}

function cc_whmcs_bridge_sso_shutdown()
{
    if( isset($_REQUEST["ccce"]) && $_REQUEST["ccce"] == "dologin" ) 
    {
        $wpusers = new wpusers();
        $wpusers->loginWpUser($_POST["username"], $_POST["password"]);
    }
    else
    {
        if( isset($_REQUEST["ccce"]) && $_REQUEST["ccce"] == "logout" ) 
        {
            $wpusers = new wpusers();
            $wpusers->logoutWpUser();
            $redir = $_SERVER["REDIRECT_URL"] . $_SERVER["REDIRECT_QUERY_STRING"];
            header("Location:" . get_option("home"));
            exit();
        }

    }

}

function cc_whmcs_bridge_sso_http(&$vars, &$and)
{
    if( isset($_REQUEST["ccce"]) && strpos($_REQUEST["ccce"], "/") !== false && strpos($_REQUEST["ccce"], "project_management.php") === false ) 
    {
        $vars = "";
    }
    else
    {
        $qLangNames = array(  );
        $qLangNames["en"] = "English";
        $qLangNames["tr"] = "Turkish";
        $qLangNames["es"] = "Spanish";
        $qLangNames["de"] = "German";
        $qLangNames["zh"] = "Chinese";
        $qLangNames["cz"] = "Czech";
        $qLangNames["dk"] = "Danish";
        $qLangNames["nl"] = "Dutch";
        $qLangNames["fr"] = "French";
        $qLangNames["it"] = "Italian";
        $qLangNames["no"] = "Norwegian";
        $qLangNames["pt_br"] = "Portuguese-br";
        $qLangNames["pt"] = "Portuguese-pt";
        $qLangNames["se"] = "Swedish";
        $langFound = false;
        if( defined("ICL_LANGUAGE_NAME_EN") ) 
        {
            $vars .= $and . "language=" . ICL_LANGUAGE_NAME_EN;
            $and = "&";
            $langFound = true;
        }
        else
        {
            if( function_exists("qtrans_getLanguage") ) 
            {
                $qLang = qtrans_getLanguage();
                if( isset($qLangNames[$qLang]) ) 
                {
                    $vars .= $and . "language=" . $qLangNames[strtolower($qLang)];
                    $and = "&";
                    $langFound = true;
                }

            }
            else
            {
                if( function_exists("ppqtrans_getLanguage") ) 
                {
                    $qLang = ppqtrans_getLanguage();
                    if( isset($qLangNames[$qLang]) ) 
                    {
                        $vars .= $and . "language=" . $qLangNames[strtolower($qLang)];
                        $and = "&";
                        $langFound = true;
                    }

                }

            }

        }

        if( !$langFound && get_option("cc_whmcs_bridge_sso_lang") ) 
        {
            $vars .= $and . "language=" . get_option("cc_whmcs_bridge_sso_lang");
            $and = "&";
        }

        if( get_option("cc_whmcs_bridge_template") ) 
        {
            $vars = str_replace("systpl=portal", "systpl=" . get_option("cc_whmcs_bridge_template"), $vars);
        }

    }

}

function cc_whmcs_bridge_sso_httpHeaders($headers)
{
    $url = parse_url(cc_whmcs_bridge_url());
    $headers[] = "bridgera:" . base64_encode($_SERVER["REMOTE_ADDR"] . "#" . md5($url["host"] . $_SERVER["REMOTE_ADDR"] . "whmcsbridge"));
    return $headers;
}

function cc_whmcs_bridge_sso_setvars_in_content($content)
{
    global $wp_query;
    if( isset($wp_query->query_vars["ccce"]) & !isset($_REQUEST["ccce"]) ) 
    {
        $_REQUEST["ccce"] = $wp_query->query_vars["ccce"];
        $_GET["ccce"] = $_REQUEST["ccce"];
    }

    return $content;
}

function cc_whmcs_bridge_sso_setvars()
{
    global $wp_query;
    if( isset($wp_query->query_vars["ccce"]) & !isset($_REQUEST["ccce"]) ) 
    {
        $_REQUEST["ccce"] = $wp_query->query_vars["ccce"];
        $_GET["ccce"] = $_REQUEST["ccce"];
    }

}

function cc_whmcs_bridge_sso_flush_rules()
{
    if( !function_exists("cc_whmcs_bridge_mainpage") ) 
    {
        return NULL;
    }

    $wordpressPageName = cc_whmcs_bridge_sso_page_slug();
    if( !$wordpressPageName ) 
    {
        return NULL;
    }

    $rules = get_option("rewrite_rules");
    if( !isset($rules["(" . $wordpressPageName . ")/(.*)\$"]) ) 
    {
        global $wp_rewrite;
        $wp_rewrite->flush_rules();
    }

}

function cc_whmcs_bridge_sso_insert_rewrite_rules($rules)
{
    if( !function_exists("cc_whmcs_bridge_mainpage") ) 
    {
        return NULL;
    }

    $wordpressPageName = cc_whmcs_bridge_sso_page_slug();
    if( !$wordpressPageName ) 
    {
        return NULL;
    }

    $newrules = array(  );
    $newrules["(" . $wordpressPageName . ")/([a-zA-Z]*)\$"] = "index.php?pagename=\$matches[1]&ccce=\$matches[2]";
    $newrules["(" . $wordpressPageName . ")/(.*)\$"] = "index.php?pagename=\$matches[1]&ccce=\$matches[2]/";
    return $newrules + $rules;
}

function cc_whmcs_bridge_sso_insert_query_vars($vars)
{
    array_push($vars, "ccce");
    array_push($vars, "cccx");
    return $vars;
}

function cc_whmcs_bridge_sso_page_slug()
{
    if( !get_option("permalink_structure") ) 
    {
        return false;
    }

    $homePage = get_option("home");
    $pageID = cc_whmcs_bridge_mainpage();
    $wordpressPageName = get_permalink($pageID);
    $wordpressPageName = str_replace($homePage . "/", "", $wordpressPageName);
    if( substr($wordpressPageName, -1) == "/" ) 
    {
        $wordpressPageName = substr($wordpressPageName, 0, -1);
    }

    return $wordpressPageName;
}

function cc_whmcs_bridge_sso_user_register($id)
{
    $wpusers = new wpusers();
    $wpusers->syncWpToWhmcs($id);
}

function cc_whmcsbridge_sso_shortcode($atts, $content = NULL, $code = "")
{
    if( !is_page() && !is_single() ) 
    {
        return "";
    }

    wp_enqueue_script("easyXDM2", plugins_url("whmcs-bridge-sso") . "/js/easyXDM/easyXDM.debug.js", array( "jquery" ));
    if( !isset($atts["systpl"]) ) 
    {
        $atts["systpl"] = get_option("cc_whmcs_bridge_template") ? get_option("cc_whmcs_bridge_template") : "portal";
    }

    $target = get_option("cc_whmcs_bridge_url");
    $params = "";
    $atts = array_merge($atts, $_GET);
    if( isset($atts["page"]) ) 
    {
        if( substr($target, -1) != "/" ) 
        {
            $target .= "/";
        }

        $target .= $atts["page"] . ".php";
        $params = "";
        foreach( $atts as $n => $v ) 
        {
            if( $n != "page" ) 
            {
                if( $params ) 
                {
                    $params .= "&";
                }

                $params .= $n . "=" . $v;
            }

        }
    }

    if( $params ) 
    {
        $target .= "?" . $params;
    }

    $remote = get_option("cc_whmcs_bridge_url") . "/modules/addons/bridgewp/iframe.php?url=" . urlencode($target);
    $remoteSwf = plugins_url("whmcs-bridge-sso") . "/js/easyXDM/easyxdm.swf";
    $content = "<!--start bridge--><div id=\"bridge\">";
    $content .= "<div id=\"bridge-frame-container\"></div>";
    $content .= "<script type=\"text/javascript\">";
    $content .= "jQuery(document).ready(function(\$) {\n\t\tnew easyXDM.Socket({\n\t\t    remote: \"" . $remote . "\",\n\t    \tswf: \"" . $remoteSwf . "\",\n\t    \tcontainer: document.getElementById(\"bridge-frame-container\"),\n\t    \tonMessage: function(message, origin){\n\t        \tthis.container.getElementsByTagName(\"iframe\")[0].style.height = (message*1 + 32) + \"px\";\n\t    \t}\n\t\t});\n\t});";
    $content .= "</script>";
    $content .= "</div><!--end bridge-->";
    return $content;
}

function cc_whmcsbridge_sso_session()
{
    $domain = get_option("cc_whmcs_bridge_sso_session_cookie_domain");
    if( !$domain ) 
    {
        return NULL;
    }

    if( substr($domain, 0, 1) != "." ) 
    {
        $domain = "." . $domain;
        update_option("cc_whmcs_bridge_sso_session_cookie_domain", $domain);
    }

    session_name("whmcs-bridge");
    ini_set("session.cookie_domain", $domain);
}

function cc_whmcsbridge_sso_get_lang(&$home, &$pid, &$url, $wordpressPageName)
{
    if( defined("ICL_LANGUAGE_CODE") && ICL_LANGUAGE_CODE && function_exists("icl_get_home_url") && $pid == "" ) 
    {
        $iclHomeUrl = icl_get_home_url();
        if( substr($iclHomeUrl, -1) == "/" ) 
        {
            $iclHomeUrl = substr($iclHomeUrl, 0, -1);
        }

        $home = $iclHomeUrl . $wordpressPageName;
    }

    if( get_option("cc_whmcs_bridge_sso_force_ssl") ) 
    {
        $url = str_replace("http://", "https://", $url);
        $home = str_replace("http://", "https://", $home);
    }

}

function cc_whmcs_bridge_sso_init()
{
    if( !is_admin() ) 
    {
    }
    else
    {
        wp_enqueue_script("whmcsbridgesso", plugins_url("whmcs-bridge-sso") . "/js/admin.js");
        wp_enqueue_style("whmcsbridgesso", plugins_url("whmcs-bridge-sso") . "/css/admin.css");
    }

}

function whmcs_bridge_sso_check_callback()
{
    echo "123";
}

function whmcs_bridge_sso_sync_callback()
{
    $wpusers = new wpusers();
    if( isset($_REQUEST["type"]) && $_REQUEST["type"] == "wptowhmcs" ) 
    {
        if( isset($_REQUEST["init"]) && $_REQUEST["init"] ) 
        {
            update_option("cc_whmcs_bridge_sso_wpsync_offset", 0);
        }

        $wpusers->syncAllWpToWHMCS();
        sleep(1);
        ob_end_clean();
        echo get_option("cc_whmcs_bridge_sso_wpsync_offset");
    }
    else
    {
        if( isset($_REQUEST["init"]) && $_REQUEST["init"] ) 
        {
            update_option("cc_whmcs_bridge_sso_start", 0);
        }

        $wpusers->syncAllWHMCSToWp();
        sleep(1);
        ob_end_clean();
        $output = get_option("cc_whmcs_bridge_sso_start");
        cc_whmcs_log(0, "Returned offset to hook with value: " . var_export($output, true));
        echo $output;
    }

    exit();
}


