<?php 
if( !class_exists("WhmcsProLicense") ) 
{
    exit( "Access denied 00C" );
}

$zl = new WhmcsProLicense(WHMCS_BRIDGE, "cc_whmcs_bridge_sso");
if( $zl->check() != md5(WHMCS_BRIDGE . "cc_whmcs_bridge_sso" . $zl->time() . "livelounge") ) 
{
    unset($zl);
    exit( "Access denied 01C" );
}

unset($zl);

class wpusers
{
    public $base_prefix = NULL;

    public function wpusers()
    {
        global $wpdb;
        if( empty($wpdb->base_prefix) ) 
        {
            $this->base_prefix = $wpdb->base_prefix;
        }
        else
        {
            $this->base_prefix = $wpdb->prefix;
        }

    }

    public function getWpUsers()
    {
        global $wpdb;
        global $blog_id;
        $users = array(  );
        $u = get_users(array( "blog_id" => $blog_id ));
        foreach( $u as $o ) 
        {
            $users[$o->user_login] = $o->ID;
        }
        return $users;
    }

    public function syncWpToWhmcs($id)
    {
        if( get_option("cc_whmcs_bridge_sso_synctype") == 10 || get_option("cc_whmcs_bridge_sso_synctype") == 20 ) 
        {
            cc_whmcs_log(0, "Sync WP user to WHMCS");
            $whmcs = new whmcs();
            $user = get_userdata($id);
            $client = $whmcs->getClient($user->data->user_email);
            $contact = $whmcs->getClient($user->data->user_email, true);
            if( !isset($client["userid"]) && !isset($contact["email"]) ) 
            {
                $result = $whmcs->addClient(get_user_meta($user->ID, "first_name", true), get_user_meta($user->ID, "last_name", true), $user->data->user_email, $user->data->user_nicename, empty($user->data->password) ? $user->data->password : md5(time()), $user->data->user_login);
            }

        }

    }

    public function syncAllWpToWHMCS()
    {
        global $wpdb;
        global $blog_id;
        $wpdb->show_errors();
        if( get_option("cc_whmcs_bridge_sso_synctype") == 10 || get_option("cc_whmcs_bridge_sso_synctype") == 20 ) 
        {
            $whmcs = new whmcs();
            $offset = get_option("cc_whmcs_bridge_sso_wpsync_offset");
            $range = 10;
            $result = count_users();
            $total = $result["total_users"];
            $users = get_users(array( "orderby" => "ID", "order" => "ASC", "number" => $range, "offset" => $offset, "fields" => "all_with_meta" ));
            foreach( $users as $user ) 
            {
                $client = $whmcs->getClient($user->data->user_email);
                $contact = $whmcs->getClient($user->data->user_email, true);
                if( !isset($client["userid"]) && !isset($contact["email"]) ) 
                {
                    $result = $whmcs->addClient(get_user_meta($user->ID, "first_name", true), get_user_meta($user->ID, "last_name", true), $user->data->user_email, $user->data->user_nicename, $user->data->user_pass, $user->data->user_login);
                }

            }
            if( $offset + $range < $total ) 
            {
                update_option("cc_whmcs_bridge_sso_wpsync_offset", $offset + $range);
            }
            else
            {
                update_option("cc_whmcs_bridge_sso_wpsync_offset", 0);
            }

        }

    }

    public function syncAllWHMCSToWp()
    {
        global $wpdb;
        global $blog_id;
        $wpdb->show_errors();
        if( get_option("cc_whmcs_bridge_sso_synctype") == "" || get_option("cc_whmcs_bridge_sso_synctype") == 0 || get_option("cc_whmcs_bridge_sso_synctype") == "20" ) 
        {
            $whmcs = new whmcs();
            $whmcsUsers = $whmcs->getUsers();
            if( is_array($whmcsUsers) && count($whmcsUsers) ) 
            {
                $role = get_option("cc_whmcs_bridge_sso_wprole") ? get_option("cc_whmcs_bridge_sso_wprole") : "subscriber";
                foreach( $whmcsUsers["clients"] as $id => $row ) 
                {
                    $query2 = sprintf("SELECT `ID` FROM `" . $this->base_prefix . "users` WHERE `user_email`='%s'", trim($row["email"]));
                    $sql2 = $wpdb->get_results($query2, ARRAY_A);
                    if( !$sql2 ) 
                    {
                        $client = $whmcs->connect("getclientsdetails", array( "clientid" => $id ));
                        $this->createWpUser($role, $client["email"], $client["firstname"], $client["lastname"], $client["companyname"], create_sessionid(12));
                        cc_whmcs_log(0, "Create user " . $row["email"] . ":" . $client["firstname"] . " " . $client["lastname"]);
                    }
                    else
                    {
                        cc_whmcs_log(0, "User " . $row["email"] . " already exists in WP");
                    }

                }
                foreach( $whmcsUsers["contacts"] as $id => $row ) 
                {
                    $query2 = sprintf("SELECT `ID` FROM `" . $this->base_prefix . "users` WHERE `user_email`='%s'", trim($row["email"]));
                    $sql2 = $wpdb->get_results($query2, ARRAY_A);
                    if( !$sql2 ) 
                    {
                        $this->createWpUser($role, $row["email"], $row["firstname"], $row["lastname"], $row["companyname"], create_sessionid(12));
                        cc_whmcs_log(0, "Create user from contact " . $row["email"] . ":" . $row["firstname"] . " " . $row["lastname"]);
                    }
                    else
                    {
                        cc_whmcs_log(0, "User " . $row["email"] . " already exists in WP");
                    }

                }
            }

        }

    }

    public function sync()
    {
        global $wpdb;
        global $blog_id;
        $wpdb->show_errors();
        $this->syncAllWHMCSToWp();
        $this->syncAllWpToWHMCS();
    }

    public function createWpUser($role, $email, $firstname, $lastname, $companyname, $password)
    {
        global $blog_id;
        $user = array(  );
        $user["user_login"] = $email;
        $user["user_email"] = $email;
        $user["first_name"] = $firstname;
        $user["last_name"] = $lastname ? $lastname : $companyname;
        $user["user_pass"] = $password;
        $user["role"] = $role;
        $id = wp_insert_user($user);
        wp_update_user(array( "ID" => $id, "role" => $role ));
        if( function_exists("add_user_to_blog") ) 
        {
            add_user_to_blog($blog_id, $id, $role);
        }

        return $id;
    }

    public function loginWpUser($login, $pass)
    {
        return wp_signon(array( "user_login" => $login, "user_password" => $pass ));
    }

    public function logoutWpUser()
    {
        return wp_logout();
    }

}


